import { EntityComponentTypes, system, world } from "@minecraft/server";

system.runInterval(() => {

    const playerList = world.getAllPlayers()

    for (let player of playerList) {

        if (player.hasComponent(EntityComponentTypes.Riding)) {

            const ride = player.getComponent(EntityComponentTypes.Riding);
            const entity = ride.entityRidingOn
            const rideInfo = JSON.stringify(entity)
            const rideToken = `{"typeId":"minecraft:dolphin","id":"${entity.id}"}`

            const rider = entity.getComponent(EntityComponentTypes.Rideable);
            const riderInfo = JSON.stringify(rider.getRiders());
            const riderToken = `[{"id":"${player.id}","typeId":"minecraft:player"}]`;

            if (rideInfo == rideToken && riderInfo == riderToken && entity.hasComponent(EntityComponentTypes.IsTamed)) {

                const dolphin = entity

                dolphin.addEffect("water_breathing", 20, {showParticles: false})
    
                const playerYRotation = (player.getViewDirection().y)/15;
                const playerXMovement = player.getVelocity().x;
                const playerZMovement = player.getVelocity().z;
    
                if (!(playerXMovement < 0.01 && playerXMovement > -0.01) && !(playerZMovement < 0.01 && playerZMovement > -0.01)) {
                        
                    const dolphinVector = { x: 0, y: playerYRotation, z: 0};
                    dolphin.applyImpulse(dolphinVector);
                }
            }
        }
    }
}, 1)


/*
world.afterEvents.playerInteractWithEntity.subscribe((data) => {
    const entity = data.target;
    const player = data.player;

    const rideable = entity.getComponent("rideable");
    const rideableInfo = JSON.stringify(rideable.getRiders());
    const rideableToken = `[{"id":"${player.id}","typeId":"minecraft:player"}]`;

    const riding = player.getComponent("riding");
    const ridingInfo = JSON.stringify(riding.entityRidingOn)
    const ridingToken = `{"typeId":"minecraft:dolphin","id":"${entity.id}"}`

    if (entity.typeId == "minecraft:dolphin" && player.hasComponent("minecraft:riding") && rideableInfo == rideableToken) {
        const dolphin = entity;

        function updateDolphin() {
            const dolphinRidingCheck = system.runInterval(() => {
                const rideableInfo = JSON.stringify(rideable.getRiders());
                const rideableToken = `[{"id":"${player.id}","typeId":"minecraft:player"}]`;

                if (dolphin.typeId == "minecraft:dolphin" && player.hasComponent("minecraft:riding") && rideableInfo == rideableToken) {
                    dolphin.runCommandAsync("effect @s water_breathing 1 1 true");
                    const playerYRotation = (player.getViewDirection().y)/17;
                    const playerXMovement = player.getVelocity().x;
                    const playerZMovement = player.getVelocity().z;
                    if (!(playerXMovement < 0.01 && playerXMovement > -0.01) && !(playerZMovement < 0.01 && playerZMovement > -0.01)) {
                        const dolphinVector = { x: 0, y: playerYRotation, z: 0};
                        dolphin.applyImpulse(dolphinVector);
                    }
                } else {
                    system.clearRun(dolphinRidingCheck);
                }
            }, 1)            
        }

        if (dolphin.hasComponent("minecraft:is_tamed")) {
            updateDolphin()
        }
        else {
            const dolphinTamedCheck = system.runInterval(() => {
                if (dolphin.hasComponent("minecraft:is_tamed")) {
                    system.clearRun(dolphinTamedCheck)
                }
            },5)
            updateDolphin()
        }
    }
})
*/